//select(Fwild@N2,Fmin,Fmax;F @N);
source procedure select(Fwild@N2,Fmin,Fmax;F@N) {
/* 1 */	language="java";
/* 1 */	maincode={{
/* 1 */	    RegularGridData N2 = (RegularGridData) Fwild.grid(0);
/* 1 */	    RegularGridData N = (RegularGridData) F.grid(0);
/* 1 */     int j=0;
/* 1 */     double fmin = Fmin.realVal();
/* 1 */     double fmax = Fmax.realVal();
/* 1 */	    for (int i=0; i<N.ct(); i++) {
/* 1 */	        while( (Fwild.realVal(j+1)<fmin) ||
/* 1 */                       (Fwild.realVal(j+1)>fmax) ) {j=j+1;}
/* 1 */	        F.set(i,Fwild.realVal(j+1));
/* 1 */	        j=j+1;
/* 1 */	     }
/* 1 */   }};
/* 1 */}	        
//*****************************************************************************
/* Statistics on a curve */
source procedure curveStatistics(input@t,output@t; ai,ti,RDi,ao,tao,RDo,tsys,RDsys) {
/* ai  (ao)       area of input (output) curve
   ti  (to)       transit time of input (output) curve
   RDi (RDo)      relative dispersion of input (output) curve
   tsys           transit time of the system
   RDsys          relative dispersion of the system
   NOTA BENE, the results are not dimensionally scaled or checked.
   A basic assumption is that both the input and output have the
   same units.  
   Corrects the calculation by 1/2*t.delta in the output signal. */
       language="java";
       maincode={{
           RegularGridData t = (RegularGridData) input.grid(0);
           double S1=0; double S2=0; double S3=0;
           double T1=0; double T2=0; double T3=0;
           for (int i=0; i<t.ct(); i++) {
               double time = t.min()+((double)i)*t.delta();
               double time2 = time*time;
               double timeO=time-t.delta()/2;
               double timeO2=timeO*timeO;
               double in=input.realVal(i);
               double ot=output.realVal(i);
               S1+=in;
               S2+=in*time;
               S3+=in*time2;
               T1+=ot;
               T2+=ot*timeO;
               T3+=ot*timeO2;
           }
           ai.set(t.delta()*S1);
           double tI=S2/S1;
           ti.set(tI);
           double rdI=( Math.sqrt((Math.abs(S3/S2)/(S2/S1))-1));
           RDi.set(rdI);
           ao.set(t.delta()*T1);
           double tO=T2/T1;
           tao.set(tO);
           double rdO=( Math.sqrt((Math.abs(T3/T2)/(T2/T1))-1));
           RDo.set(rdO);
           tsys.set(tO-tI);
           RDsys.set( Math.sqrt(rdO*tO*rdO*tO-rdI*tI*rdI*tI)/(tO-tI) );
         }};
} // END
import nsrunit; unit conversion on;

math RandomPerfusion {
real Nmax = 20;
real Fmean = 1 ml/(g*min);
// SET FLOW PARAMETERS
real N2max=2*Nmax;
realDomain N; N.min=1; N.max=Nmax; N.delta=1;
realDomain N2; N2.min=1; N2.max=N2max; N2.delta=1;
real rFmean  = 1.0 ;
real rFStDev = 0.3 ;
real rFmin   = 0.1 ;
real rFmax   = 2.0 ;
// PROCESS
// Generate twice as many random flows as necessary
real rFwild(N2) ;
rFwild = rFmean + rFStDev*randomg(); 
// Select first N of them as the rflows for N intervals
// and rFmin<Fwild<rFmax, include rFmin and rFmax
real rF(N) ;
select(rFwild@N2,rFmin,rFmax,rF@N);
// GET RELATIVE FLOW PDF
realDomain rf; rf.min=rFmin; rf.max=rFmax; rf.delta=0.001;
extern real rfpdf(rf);
// GET INITIAL WEIGHTS
real wdf(N);
wdf= rfpdf(rF(N));
real sumwdf = sum(N=N.min to N.max, wdf);
real sumwxf = sum(N=N.min to N.max, wdf*rF);
real factor = sumwdf/sumwxf;
real w(N), normf(N);
w=wdf/sumwdf;
normf=rF*sumwdf/sumwxf;
real F1=normf(1)*Fmean;
real F2=normf(2)*Fmean;
real F3=normf(3)*Fmean;
real F4=normf(4)*Fmean;
real F5=normf(5)*Fmean;
real F6=normf(6)*Fmean;
real F7=normf(7)*Fmean;
real F8=normf(8)*Fmean;
real F9=normf(9)*Fmean;
real F10=normf(10)*Fmean;
real F11=normf(11)*Fmean;
real F12=normf(12)*Fmean;
real F13=normf(13)*Fmean;
real F14=normf(14)*Fmean;
real F15=normf(15)*Fmean;
real F16=normf(16)*Fmean;
real F17=normf(17)*Fmean;
real F18=normf(18)*Fmean;
real F19=normf(19)*Fmean;
real F20=normf(20)*Fmean;
real weight1;
real weight2;
real weight3;
real weight4;
real weight5;
real weight6;
real weight7;
real weight8;
real weight9;
real weight10;
real weight11;
real weight12;
real weight13;
real weight14;
real weight15;
real weight16;
real weight17;
real weight18;
real weight19;
real weight20;
weight1=w(1);
weight2=w(2);
weight3=w(3);
weight4=w(4);
weight5=w(5);
weight6=w(6);
weight7=w(7);
weight8=w(8);
weight9=w(9);
weight10=w(10);
weight11=w(11);
weight12=w(12);
weight13=w(13);
weight14=w(14);
weight15=w(15);
weight16=w(16);
weight17=w(17);
weight18=w(18);
weight19=w(19);
weight20=w(20);
real PSisf=1 ml/(g*min);
realDomain t s; t.min=0; t.max=30; t.delta = 0.1;
real L = 0.1 cm;
real Ndivx = 31;
realDomain x cm ; x.min=0; x.max=L; x.ct = Ndivx;
// PARAMETERS
real PS1 = 1 ml/(g*min);	// ExchangeRate between Vp and Visf
real Vp = 0.05 ml/g;		// Volume of Vp
real Visf = 0.15 ml/g;		// Volume of Visf
real D1 = 1e-6 cm^2/sec;	// Diff Coeff in Vp
real D2 = 1e-6 cm^2/sec;	// Diff Coeff in Visf
extern real Cin(t) mM;		// Inflow Concentration
// DEPENDENT VARIABLES
real Cp1(t,x) mM;	
real Cisf1(t,x) mM;	
real Cp1out(t) mM;		// Outflow Conc
private real C1ic = 0 mM;
private real C2ic = 0 mM;
// INITIAL CONDITIONS
when(t=t.min) Cp1=C1ic;
when(t=t.min) Cisf1=C2ic;
// BOUNDARY CONDITIONS
when  (x=x.min) (-F1*L/Vp)*(Cp1-Cin)+D1*Cp1:x = 0; 
when  (x=x.max) { Cp1:x = 0; Cp1out = Cp1;}
when(x=x.min) {Cisf1:x=0; }
when(x=x.max) {Cisf1:x=0; }
real Cp2(t,x) mM;	
real Cisf2(t,x) mM;	
real Cp2out(t) mM;		// Outflow Conc
when(t=t.min) Cp2=C1ic;
when(t=t.min) Cisf2=C2ic;
when  (x=x.min) (-F2*L/Vp)*(Cp2-Cin)+D1*Cp2:x = 0; 
when  (x=x.max) { Cp2:x = 0; Cp2out = Cp2;}
when(x=x.min) {Cisf2:x=0; }
when(x=x.max) {Cisf2:x=0; }
real Cp3(t,x) mM;	
real Cisf3(t,x) mM;	
real Cp3out(t) mM;		// Outflow Conc
when(t=t.min) Cp3=C1ic;
when(t=t.min) Cisf3=C2ic;
when  (x=x.min) (-F3*L/Vp)*(Cp3-Cin)+D1*Cp3:x = 0; 
when  (x=x.max) { Cp3:x = 0; Cp3out = Cp3;}
when(x=x.min) {Cisf3:x=0; }
when(x=x.max) {Cisf3:x=0; }
real Cp4(t,x) mM;	
real Cisf4(t,x) mM;	
real Cp4out(t) mM;		// Outflow Conc
when(t=t.min) Cp4=C1ic;
when(t=t.min) Cisf4=C2ic;
when  (x=x.min) (-F4*L/Vp)*(Cp4-Cin)+D1*Cp4:x = 0; 
when  (x=x.max) { Cp4:x = 0; Cp4out = Cp4;}
when(x=x.min) {Cisf4:x=0; }
when(x=x.max) {Cisf4:x=0; }
real Cp5(t,x) mM;	
real Cisf5(t,x) mM;	
real Cp5out(t) mM;		// Outflow Conc
when(t=t.min) Cp5=C1ic;
when(t=t.min) Cisf5=C2ic;
when  (x=x.min) (-F5*L/Vp)*(Cp5-Cin)+D1*Cp5:x = 0; 
when  (x=x.max) { Cp5:x = 0; Cp5out = Cp5;}
when(x=x.min) {Cisf5:x=0; }
when(x=x.max) {Cisf5:x=0; }
real Cp6(t,x) mM;	
real Cisf6(t,x) mM;	
real Cp6out(t) mM;		// Outflow Conc
when(t=t.min) Cp6=C1ic;
when(t=t.min) Cisf6=C2ic;
when  (x=x.min) (-F6*L/Vp)*(Cp6-Cin)+D1*Cp6:x = 0; 
when  (x=x.max) { Cp6:x = 0; Cp6out = Cp6;}
when(x=x.min) {Cisf6:x=0; }
when(x=x.max) {Cisf6:x=0; }
real Cp7(t,x) mM;	
real Cisf7(t,x) mM;	
real Cp7out(t) mM;		// Outflow Conc
when(t=t.min) Cp7=C1ic;
when(t=t.min) Cisf7=C2ic;
when  (x=x.min) (-F7*L/Vp)*(Cp7-Cin)+D1*Cp7:x = 0; 
when  (x=x.max) { Cp7:x = 0; Cp7out = Cp7;}
when(x=x.min) {Cisf7:x=0; }
when(x=x.max) {Cisf7:x=0; }
real Cp8(t,x) mM;	
real Cisf8(t,x) mM;	
real Cp8out(t) mM;		// Outflow Conc
when(t=t.min) Cp8=C1ic;
when(t=t.min) Cisf8=C2ic;
when  (x=x.min) (-F8*L/Vp)*(Cp8-Cin)+D1*Cp8:x = 0; 
when  (x=x.max) { Cp8:x = 0; Cp8out = Cp8;}
when(x=x.min) {Cisf8:x=0; }
when(x=x.max) {Cisf8:x=0; }
real Cp9(t,x) mM;	
real Cisf9(t,x) mM;	
real Cp9out(t) mM;		// Outflow Conc
when(t=t.min) Cp9=C1ic;
when(t=t.min) Cisf9=C2ic;
when  (x=x.min) (-F9*L/Vp)*(Cp9-Cin)+D1*Cp9:x = 0; 
when  (x=x.max) { Cp9:x = 0; Cp9out = Cp9;}
when(x=x.min) {Cisf9:x=0; }
when(x=x.max) {Cisf9:x=0; }
real Cp10(t,x) mM;	
real Cisf10(t,x) mM;	
real Cp10out(t) mM;		// Outflow Conc
when(t=t.min) Cp10=C1ic;
when(t=t.min) Cisf10=C2ic;
when  (x=x.min) (-F10*L/Vp)*(Cp10-Cin)+D1*Cp10:x = 0; 
when  (x=x.max) { Cp10:x = 0; Cp10out = Cp10;}
when(x=x.min) {Cisf10:x=0; }
when(x=x.max) {Cisf10:x=0; }
real Cp11(t,x) mM;	
real Cisf11(t,x) mM;	
real Cp11out(t) mM;		// Outflow Conc
when(t=t.min) Cp11=C1ic;
when(t=t.min) Cisf11=C2ic;
when  (x=x.min) (-F11*L/Vp)*(Cp11-Cin)+D1*Cp11:x = 0; 
when  (x=x.max) { Cp11:x = 0; Cp11out = Cp11;}
when(x=x.min) {Cisf11:x=0; }
when(x=x.max) {Cisf11:x=0; }
real Cp12(t,x) mM;	
real Cisf12(t,x) mM;	
real Cp12out(t) mM;		// Outflow Conc
when(t=t.min) Cp12=C1ic;
when(t=t.min) Cisf12=C2ic;
when  (x=x.min) (-F12*L/Vp)*(Cp12-Cin)+D1*Cp12:x = 0; 
when  (x=x.max) { Cp12:x = 0; Cp12out = Cp12;}
when(x=x.min) {Cisf12:x=0; }
when(x=x.max) {Cisf12:x=0; }
real Cp13(t,x) mM;	
real Cisf13(t,x) mM;	
real Cp13out(t) mM;		// Outflow Conc
when(t=t.min) Cp13=C1ic;
when(t=t.min) Cisf13=C2ic;
when  (x=x.min) (-F13*L/Vp)*(Cp13-Cin)+D1*Cp13:x = 0; 
when  (x=x.max) { Cp13:x = 0; Cp13out = Cp13;}
when(x=x.min) {Cisf13:x=0; }
when(x=x.max) {Cisf13:x=0; }
real Cp14(t,x) mM;	
real Cisf14(t,x) mM;	
real Cp14out(t) mM;		// Outflow Conc
when(t=t.min) Cp14=C1ic;
when(t=t.min) Cisf14=C2ic;
when  (x=x.min) (-F14*L/Vp)*(Cp14-Cin)+D1*Cp14:x = 0; 
when  (x=x.max) { Cp14:x = 0; Cp14out = Cp14;}
when(x=x.min) {Cisf14:x=0; }
when(x=x.max) {Cisf14:x=0; }
real Cp15(t,x) mM;	
real Cisf15(t,x) mM;	
real Cp15out(t) mM;		// Outflow Conc
when(t=t.min) Cp15=C1ic;
when(t=t.min) Cisf15=C2ic;
when  (x=x.min) (-F15*L/Vp)*(Cp15-Cin)+D1*Cp15:x = 0; 
when  (x=x.max) { Cp15:x = 0; Cp15out = Cp15;}
when(x=x.min) {Cisf15:x=0; }
when(x=x.max) {Cisf15:x=0; }
real Cp16(t,x) mM;	
real Cisf16(t,x) mM;	
real Cp16out(t) mM;		// Outflow Conc
when(t=t.min) Cp16=C1ic;
when(t=t.min) Cisf16=C2ic;
when  (x=x.min) (-F16*L/Vp)*(Cp16-Cin)+D1*Cp16:x = 0; 
when  (x=x.max) { Cp16:x = 0; Cp16out = Cp16;}
when(x=x.min) {Cisf16:x=0; }
when(x=x.max) {Cisf16:x=0; }
real Cp17(t,x) mM;	
real Cisf17(t,x) mM;	
real Cp17out(t) mM;		// Outflow Conc
when(t=t.min) Cp17=C1ic;
when(t=t.min) Cisf17=C2ic;
when  (x=x.min) (-F17*L/Vp)*(Cp17-Cin)+D1*Cp17:x = 0; 
when  (x=x.max) { Cp17:x = 0; Cp17out = Cp17;}
when(x=x.min) {Cisf17:x=0; }
when(x=x.max) {Cisf17:x=0; }
real Cp18(t,x) mM;	
real Cisf18(t,x) mM;	
real Cp18out(t) mM;		// Outflow Conc
when(t=t.min) Cp18=C1ic;
when(t=t.min) Cisf18=C2ic;
when  (x=x.min) (-F18*L/Vp)*(Cp18-Cin)+D1*Cp18:x = 0; 
when  (x=x.max) { Cp18:x = 0; Cp18out = Cp18;}
when(x=x.min) {Cisf18:x=0; }
when(x=x.max) {Cisf18:x=0; }
real Cp19(t,x) mM;	
real Cisf19(t,x) mM;	
real Cp19out(t) mM;		// Outflow Conc
when(t=t.min) Cp19=C1ic;
when(t=t.min) Cisf19=C2ic;
when  (x=x.min) (-F19*L/Vp)*(Cp19-Cin)+D1*Cp19:x = 0; 
when  (x=x.max) { Cp19:x = 0; Cp19out = Cp19;}
when(x=x.min) {Cisf19:x=0; }
when(x=x.max) {Cisf19:x=0; }
real Cp20(t,x) mM;	
real Cisf20(t,x) mM;	
real Cp20out(t) mM;		// Outflow Conc
when(t=t.min) Cp20=C1ic;
when(t=t.min) Cisf20=C2ic;
when  (x=x.min) (-F20*L/Vp)*(Cp20-Cin)+D1*Cp20:x = 0; 
when  (x=x.max) { Cp20:x = 0; Cp20out = Cp20;}
when(x=x.min) {Cisf20:x=0; }
when(x=x.max) {Cisf20:x=0; }
Cp1:t = D1*Cp1:x:x -(F1*L/Vp)*Cp1:x +PS1/Vp*(Cisf1-Cp1);
Cisf1:t = D2*Cisf1:x:x +PS1/Visf*(Cp1-Cisf1)
        +PSisf/Visf*(Cisf2-Cisf1);
Cp2:t = D1*Cp2:x:x -(F2*L/Vp)*Cp2:x +PS1/Vp*(Cisf2-Cp2);
Cisf2:t = D2*Cisf2:x:x +PS1/Visf*(Cp2-Cisf2)
        +PSisf/Visf*(Cisf1-Cisf2)
        +PSisf/Visf*(Cisf3-Cisf2);
Cp3:t = D1*Cp3:x:x -(F3*L/Vp)*Cp3:x +PS1/Vp*(Cisf3-Cp3);
Cisf3:t = D2*Cisf3:x:x +PS1/Visf*(Cp3-Cisf3)
        +PSisf/Visf*(Cisf2-Cisf3)
        +PSisf/Visf*(Cisf4-Cisf3);
Cp4:t = D1*Cp4:x:x -(F4*L/Vp)*Cp4:x +PS1/Vp*(Cisf4-Cp4);
Cisf4:t = D2*Cisf4:x:x +PS1/Visf*(Cp4-Cisf4)
        +PSisf/Visf*(Cisf3-Cisf4)
        +PSisf/Visf*(Cisf5-Cisf4);
Cp5:t = D1*Cp5:x:x -(F5*L/Vp)*Cp5:x +PS1/Vp*(Cisf5-Cp5);
Cisf5:t = D2*Cisf5:x:x +PS1/Visf*(Cp5-Cisf5)
        +PSisf/Visf*(Cisf4-Cisf5)
        +PSisf/Visf*(Cisf6-Cisf5);
Cp6:t = D1*Cp6:x:x -(F6*L/Vp)*Cp6:x +PS1/Vp*(Cisf6-Cp6);
Cisf6:t = D2*Cisf6:x:x +PS1/Visf*(Cp6-Cisf6)
        +PSisf/Visf*(Cisf5-Cisf6)
        +PSisf/Visf*(Cisf7-Cisf6);
Cp7:t = D1*Cp7:x:x -(F7*L/Vp)*Cp7:x +PS1/Vp*(Cisf7-Cp7);
Cisf7:t = D2*Cisf7:x:x +PS1/Visf*(Cp7-Cisf7)
        +PSisf/Visf*(Cisf6-Cisf7)
        +PSisf/Visf*(Cisf8-Cisf7);
Cp8:t = D1*Cp8:x:x -(F8*L/Vp)*Cp8:x +PS1/Vp*(Cisf8-Cp8);
Cisf8:t = D2*Cisf8:x:x +PS1/Visf*(Cp8-Cisf8)
        +PSisf/Visf*(Cisf7-Cisf8)
        +PSisf/Visf*(Cisf9-Cisf8);
Cp9:t = D1*Cp9:x:x -(F9*L/Vp)*Cp9:x +PS1/Vp*(Cisf9-Cp9);
Cisf9:t = D2*Cisf9:x:x +PS1/Visf*(Cp9-Cisf9)
        +PSisf/Visf*(Cisf8-Cisf9)
        +PSisf/Visf*(Cisf10-Cisf9);
Cp10:t = D1*Cp10:x:x -(F10*L/Vp)*Cp10:x +PS1/Vp*(Cisf10-Cp10);
Cisf10:t = D2*Cisf10:x:x +PS1/Visf*(Cp10-Cisf10)
         +PSisf/Visf*(Cisf9-Cisf10)
         +PSisf/Visf*(Cisf11-Cisf10);
Cp11:t = D1*Cp11:x:x -(F11*L/Vp)*Cp11:x +PS1/Vp*(Cisf11-Cp11);
Cisf11:t = D2*Cisf11:x:x +PS1/Visf*(Cp11-Cisf11)
         +PSisf/Visf*(Cisf10-Cisf11)
         +PSisf/Visf*(Cisf12-Cisf11);
Cp12:t = D1*Cp12:x:x -(F12*L/Vp)*Cp12:x +PS1/Vp*(Cisf12-Cp12);
Cisf12:t = D2*Cisf12:x:x +PS1/Visf*(Cp12-Cisf12)
         +PSisf/Visf*(Cisf11-Cisf12)
         +PSisf/Visf*(Cisf13-Cisf12);
Cp13:t = D1*Cp13:x:x -(F13*L/Vp)*Cp13:x +PS1/Vp*(Cisf13-Cp13);
Cisf13:t = D2*Cisf13:x:x +PS1/Visf*(Cp13-Cisf13)
         +PSisf/Visf*(Cisf12-Cisf13)
         +PSisf/Visf*(Cisf14-Cisf13);
Cp14:t = D1*Cp14:x:x -(F14*L/Vp)*Cp14:x +PS1/Vp*(Cisf14-Cp14);
Cisf14:t = D2*Cisf14:x:x +PS1/Visf*(Cp14-Cisf14)
         +PSisf/Visf*(Cisf13-Cisf14)
         +PSisf/Visf*(Cisf15-Cisf14);
Cp15:t = D1*Cp15:x:x -(F15*L/Vp)*Cp15:x +PS1/Vp*(Cisf15-Cp15);
Cisf15:t = D2*Cisf15:x:x +PS1/Visf*(Cp15-Cisf15)
         +PSisf/Visf*(Cisf14-Cisf15)
         +PSisf/Visf*(Cisf16-Cisf15);
Cp16:t = D1*Cp16:x:x -(F16*L/Vp)*Cp16:x +PS1/Vp*(Cisf16-Cp16);
Cisf16:t = D2*Cisf16:x:x +PS1/Visf*(Cp16-Cisf16)
         +PSisf/Visf*(Cisf15-Cisf16)
         +PSisf/Visf*(Cisf17-Cisf16);
Cp17:t = D1*Cp17:x:x -(F17*L/Vp)*Cp17:x +PS1/Vp*(Cisf17-Cp17);
Cisf17:t = D2*Cisf17:x:x +PS1/Visf*(Cp17-Cisf17)
         +PSisf/Visf*(Cisf16-Cisf17)
         +PSisf/Visf*(Cisf18-Cisf17);
Cp18:t = D1*Cp18:x:x -(F18*L/Vp)*Cp18:x +PS1/Vp*(Cisf18-Cp18);
Cisf18:t = D2*Cisf18:x:x +PS1/Visf*(Cp18-Cisf18)
         +PSisf/Visf*(Cisf17-Cisf18)
         +PSisf/Visf*(Cisf19-Cisf18);
Cp19:t = D1*Cp19:x:x -(F19*L/Vp)*Cp19:x +PS1/Vp*(Cisf19-Cp19);
Cisf19:t = D2*Cisf19:x:x +PS1/Visf*(Cp19-Cisf19)
         +PSisf/Visf*(Cisf18-Cisf19)
         +PSisf/Visf*(Cisf20-Cisf19);
Cp20:t = D1*Cp20:x:x -(F20*L/Vp)*Cp20:x +PS1/Vp*(Cisf20-Cp20);
Cisf20:t = D2*Cisf20:x:x +PS1/Visf*(Cp20-Cisf20)
         +PSisf/Visf*(Cisf19-Cisf20);
real sumout(t) mM;
sumout = Cp1out*weight1*normf(1)
       +Cp2out*weight2*normf(2)
       +Cp3out*weight3*normf(3)
       +Cp4out*weight4*normf(4)
       +Cp5out*weight5*normf(5)
       +Cp6out*weight6*normf(6)
       +Cp7out*weight7*normf(7)
       +Cp8out*weight8*normf(8)
       +Cp9out*weight9*normf(9)
       +Cp10out*weight10*normf(10)
       +Cp11out*weight11*normf(11)
       +Cp12out*weight12*normf(12)
       +Cp13out*weight13*normf(13)
       +Cp14out*weight14*normf(14)
       +Cp15out*weight15*normf(15)
       +Cp16out*weight16*normf(16)
       +Cp17out*weight17*normf(17)
       +Cp18out*weight18*normf(18)
       +Cp19out*weight19*normf(19)
       +Cp20out*weight20*normf(20);
real Q(t) umol/(g*min);
when(t=t.min) Q=0;
Q=Fmean*(Cin-sumout);
/*
   ai  ( ao)          area of input (output) curve
   ti  ( to,  tsys)   transit time of input (output, system)
   RDi (RDo, RDsys)   relative dispersion of input (output, system) 
*/
real ai, ti,RDi,ao,tao,RDo,tsys,RDsys;
curveStatistics(Cin@t,Cout@t,ai,ti,RDi,ao,tao,RDo,tsys,RDsys);
}
// This MML file generated from RandomFlows.mpc using MPC.
