import nsrunit; unit conversion on;

math EnzymeConvert {

//%START odeDomains 
realDomain t s; t.min=0; t.max=30; t.delta=0.1;
//%END odeDomains

// PARAMETERS AND VARIABLES
real A(t) mM;	// Concentration of C1 in V
real A0 = 1 mM;	// Initial Concentration of C1
real B(t) mM;	// Concentration of C2 in V
real B0 = 0 mM;	// Initial Concentration of C2
when(t=t.min) {A=A0; B=B0; }

//%START enzymeParms
real Complex(t) mM;
real Enzyme(t) mM;
real Etot = 0.1 mM;
real kf1 = 2 mM^(-1)*s^(-1);
real kb1 = 1 s^(-1);
real kf2 = 1 s^(-1);
real kb2 = 1 mM^(-1)*s^(-1);
when(t=t.min) { Complex=0; Enzyme=Etot; }         
//%END enzymeParms

//%START enzymeCalc
A:t = -kf1*A*Enzyme + kb1*Complex;
B:t =  kf2*Complex - kb2*B*Enzyme;
Enzyme:t = -(kf1*A + kb2*B)*Enzyme 
           + (kb1 + kf2)*Complex;
Complex:t = (kf1*A + kb2*B)*Enzyme 
           - (kb1 + kf2)*Complex;
//%END enzymeCalc

}
