import nsrunit; unit conversion on;
math FlowPDE { // Partial Differential Equation Model for capillary

//%START pdeDomains
realDomain  t s; t.min=0; t.max=30; t.delta = 0.1;
real L = 0.1 cm;
real Ndivx = 31;
realDomain x cm ; x.min=0; x.max=L; x.ct = Ndivx;
//%END pdeDomains

// Parameters and Variables
real F = 1 ml/(min);	// Flow
real V = 0.05 ml;	// Volume
real D = 1e-6 cm^2/s;	// Diffusion coefficient
real C0 = 0 mM;		// Initial Concentration
extern real Cin(t) mM;	// Input conc from func generator
real C(t,x) mM;		// Concentration 
real Cout(t) mM;	// Outflow conc
when(t=t.min) C=C0;	// Set Init condition

//%START flowBC
when  (x=x.min) (-F*L/V)*(C-Cin)+D*C:x = 0; 
when  (x=x.max) { C:x = 0; Cout = C;}
//%END flowBC

//%START flowDiffCalc
C:t =  -(F*L/V)*C:x
       + D*C:x:x ;
//%END flowDiffCalc
}

