/* MODEL NUMBER:
   MODEL NAME:
   SHORT DESCRIPTION:
*/
import nsrunit; unit conversion on;
//
/*
   2 compartment model with flow and consumption
*/
math Comp2_A {
//% INDEPENDENT VARIABLE
realDomain t s; t.min=0; t.max=30; t.delta = 0.1;
// PARAMETERS
real Fp = 1 ml/(g*min);		// Flow 
real PSA = 1 ml/(g*min);	// ExchangeRate between compartments
real Gp =	0 ml/(g*min);	// Consumption rate
real Gc =	0 ml/(g*min);	// Consumption rate
real Vp = 0.05 ml/g;		// Volume of V%n%
real Vc = 0.60 ml/g;		// Volume of V%n%
extern real Ain(t) mM;		// Inflow Concentration
// DEPENDENT VARIABLES
real Ap(t) mM;		// Concentration 
real Ac(t) mM;		// Concentration 
real Aout(t) mM;		// Outflow Conc
private real Apic = 0 mM;	// Init Conc of C%n% in V%n%
private real Acic = 0 mM;	// Init Conc of C%n% in V%n%
// INITIAL CONDITIONS
when(t=t.min) Ap=Apic;
when(t=t.min) Ac=Acic;
// ORDINARY DIFFERENTIAL EQUATIONS
Ap:t = (Fp/Vp)*(Ain-Aout)
     +PSA/Vp*(Ac-Ap)
     -(Gp/Vp)*Ap;
Aout = Ap;
Ac:t = PSA/Vc*(Ap-Ac)
     -(Gc/Vc)*Ac;
}
/*
DETAILED DESCRIPTION:
//
KEY WORDS:
//
REFERENCES:
// 
REVISION HISTORY:
//
JSim SOFTWARE COPYRIGHT AND REQUEST FOR ACKNOWLEDGMENT OF USE:
   
JSim software was developed with support from NIH grants HL088516, 
and HL073598. Please cite these grants in any publication for which 
this software is used and send one reprint of published abstracts or 
articles to the address given below. Academic use is unrestricted. 
Software may be copied so long as this copyright notice is included.
Copyright (C) 1999-2011 University of Washington.
Contact Information:
 
The National Simulation Resource,  
Director J. B. Bassingthwaighte, 
Department of Bioengineering, 
University of Washington, Seattle, WA 
98195-5061
*/
// This MML file generated from ../COMP2/Comp2_A.mpc using MPC.
