import nsrunit; unit conversion on;
math Diffusion {
//%START pdeDomains 
real L = 1 cm, Ngrid=101;
realDomain t s; t.min=0; t.max=500; t.delta=0.1;
realDomain x cm; x.min=0.0; x.max=L; x.ct=Ngrid;
//%END pdeDomains

//PARAMETERS AND VARIABLES
real C(t,x) mM; 
real C0(x) = (1 mM)*(if(x>=L/2-L/20 and x<L/2+L/20) (1 cm)/(L/10) else 0);
real D = 1e-5 cm^2/s;
when(t=t.min) C=C0;          

//%START noFlowBC
when(x=x.min)  C:x=0;
when(x=x.max)  C:x=0; 
//%END noFlowBC

//%START diffusionCalc
C:t = D*C:x:x ;
//%END diffusionCalc

}
