import nsrunit; unit conversion on;
math OnOffMembrane {
realDomain t sec; t.min=0; t.max=30; t.delta=0.1;
//%START onOffMembraneModel

//%START onOffMembraneParms
real V = 0.05 ml;	// Volume of solution with M
real S = 1 cm^2;	// Surface area of membrane
real SoV = S/V;		// Surface to volume ratio
real KdB = 10 uM;	// Dissociation constant
real kon = 0.001 uM^(-1)*s^(-1);// on rate M+B->MB
real kof = KdB*kon;		// off rate MB->B+B
real M0 = 1 mM;		// Initial Concentration of molecules
real Btot = 0.05 umol/cm^2;	// Initial Concentration of free binding sites
real MB0 = 0 umol/cm^2;	// Initial concentration of complex MB
real M(t) mM;		// Concentration of molecule M
real B(t) umol/cm^2;	// Concentration of open binding sites
real MB(t) umol/cm^2;	// Concentration of M bound to B;
when(t=t.min) M=M0;	// Initial condition for M
when(t=t.min) B=Btot;	// Initial condition for B
when(t=t.min) MB=MB0;	// Initial condition for MB
//%END onOffMembraneParms

//%START onOffMembraneCalc
M:t = (-kon*M*B + kof*MB)*SoV;
B:t =  -kon*M*B + kof*MB ;
MB:t =  kon*M*B - kof*MB;
//%END onOffMembraneCalc;
real allM(t) mM;
allM = M+MB*SoV;
real allB(t) pmol/cm^2;
allB = B+MB;

//%END onOffMembraneModel
}
